﻿using System;
using System.IO;
using System.Net;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Text;
using System.Web;

namespace PushService
{
	internal static class PushHelper
	{
		public static void Push(Uri uri, OAuthToken accessToken, string message)
		{
			HttpWebRequest request = HttpWebRequest.Create(uri) as HttpWebRequest;
			request.Method = "POST";
			//Change this depending on the type of notification you need to do. Raw is just text
			string notificationType = "wns/raw";
			string contentType = "application/octet-stream";
			request.Headers.Add("X-WNS-Type", notificationType);
			request.ContentType = contentType;
			request.Headers.Add("Authorization", String.Format("Bearer {0}", accessToken.AccessToken));

			byte[] contentInBytes = Encoding.UTF8.GetBytes(message);
			using (Stream requestStream = request.GetRequestStream())
				requestStream.Write(contentInBytes, 0, contentInBytes.Length);
			try
			{
				using (HttpWebResponse webResponse = (HttpWebResponse)request.GetResponse())
				{
					string code = webResponse.StatusCode.ToString();
				}
			}
			catch (Exception)
			{
				throw;
			}
		}

		public static OAuthToken GetAccessToken(string secret, string sid)
		{
			var urlEncodedSecret = HttpUtility.UrlEncode(secret);
			var urlEncodedSid = HttpUtility.UrlEncode(sid);

			var body =
			  String.Format("grant_type=client_credentials&client_id={0}&client_secret={1}&scope=notify.windows.com", urlEncodedSid, urlEncodedSecret);

			string response;
			using (var client = new System.Net.WebClient())
			{
				client.Headers.Add("Content-Type", "application/x-www-form-urlencoded");
				response = client.UploadString("https://login.live.com/accesstoken.srf", body);
			}
			using (var ms = new MemoryStream(Encoding.Unicode.GetBytes(response)))
			{
				var ser = new DataContractJsonSerializer(typeof(OAuthToken));
				var oAuthToken = (OAuthToken)ser.ReadObject(ms);
				return oAuthToken;
			}
		}
	}

	[DataContract]
	internal class OAuthToken
	{
		[DataMember(Name = "access_token")]
		public string AccessToken { get; set; }
		[DataMember(Name = "token_type")]
		public string TokenType { get; set; }
	}
}
